#define Maxcol 160
#define Posuvx 160
#define Posuvy 100

#include "3d1.h"
#include "fillp.h"

#include "hvezd.c"
#include "tvary.c"
#include "cubic.c"
#include "new-2.c"
#include "textr.c"
#include "texl.c"


object3D   obj;
object3D   obj2;
float sint[361];  
float cost[361];  
Point3D light;
Point3Df lightn;
int      numshow;
Point3D cam;

/*nejake procedury jsou zvlast pro prehlednost*/
#include "norm.c"
#include "rot.c"
#include "polyop.c"
/*dalsi procedury*/

void sincosini()
{
 int i;
 for (i=0;i<361;i++)
  { sint[i]=sin(i*PI/180);
    cost[i]=cos(i*PI/180);
   }  
} 

void uppgradeobject(object3D *objp)
{
  objp->degre.x+=objp->degreinc.x;
  objp->degre.y+=objp->degreinc.y;
  objp->degre.z+=objp->degreinc.z;
  if (objp->degre.x<0) objp->degre.x+=360;
  if (objp->degre.x>360) objp->degre.x-=360;
  if (objp->degre.y<0) objp->degre.y+=360;
  if (objp->degre.y>360) objp->degre.y-=360;
  if (objp->degre.z<0) objp->degre.z+=360;
  if (objp->degre.z>360) objp->degre.z-=360;
}

void perspektive(object3D *objp)
{
 int i;
  for(i=1;i<(objp->Nvertex+1);i++)
   { 
    objp->scrpoints[i].x=(int)(Posuvx+(((objp->rotvertexes[i].x)*256)/(objp->rotvertexes[i].z+cam.z)));
    objp->scrpoints[i].y=(int)(Posuvy+(((-(objp)->rotvertexes[i].y)*256)/(objp->rotvertexes[i].z+cam.z)));
   }  
}

void Gputpolys(object3D *objp)
{
 int i;
 int x1,x2,y1,y2,x3,y3;
 int col1,col2,col3;
 int cispol;
 int vert1,vert2,vert3;
 
 QUICKSORT(1,numshow,objp);
 for(i=numshow;i>=1;i--)
   {
    cispol=objp->sortdata.sortlist[i][0];   /*cislo setrideneho polygonu*/
    if (objp->polys[cispol].hidden==2)  /*je videt ci ne*/
     {
      vert1=objp->polys[cispol].whichvertexes[1];
      x1=objp->polys[cispol].cornerpoints[1].x;
      y1=objp->polys[cispol].cornerpoints[1].y;

      col1=objp->vertcol[vert1];
      
      vert2=objp->polys[cispol].whichvertexes[2];
      x2=objp->polys[cispol].cornerpoints[2].x;
      y2=objp->polys[cispol].cornerpoints[2].y;
      col2=objp->vertcol[vert2];

      vert3=objp->polys[cispol].whichvertexes[3];
      x3=objp->polys[cispol].cornerpoints[3].x;
      y3=objp->polys[cispol].cornerpoints[3].y;
      col3=objp->vertcol[vert3];
      
      Gourtriangle(x1,y1,x2,y2,x3,y3,col1,col2,col3,virt);
     }    
   }
}

void putWirePolys(object3D *objp,unsigned char barva)
{
 int i;
 int x1,x2,x3,y1,y2,y3;
 
 for(i=1;i<((objp->Npolys)+1);i++)
   {
      x1=objp->polys[i].cornerpoints[1].x;
      y1=objp->polys[i].cornerpoints[1].y;
      x2=objp->polys[i].cornerpoints[2].x;
      y2=objp->polys[i].cornerpoints[2].y;
      x3=objp->polys[i].cornerpoints[3].x;
      y3=objp->polys[i].cornerpoints[3].y;
      DrawLine(x1,y1,x2,y2,barva,virt);
      DrawLine(x2,y2,x3,y3,barva,virt);
      DrawLine(x1,y1,x3,y3,barva,virt);
     }    
}

void textrputpolys(object3D *objp)
{
 int cispol;
 int i;

 QUICKSORT(1,numshow,objp);
 for(i=numshow;i>=1;i--)
   {
    cispol=objp->sortdata.sortlist[i][0];   /*cislo setrideneho polygonu*/
    if (objp->polys[cispol].hidden==2)  /*je videt ci ne*/
     {
      texpolygon(&(objp->polys[cispol]),virt);
     }
   }
}


void part3D1(void) 
{
   int incz=1,pocet=0;
   int x;
   int y;
   char skonceno=23;

   light.x=0;
   light.y=0;
   light.z=-1;


 //declare2(&obj);
 {int RED=152,GREEN=300,BLUE=200;
  for(col=255;col>0;col--)
  {
   palettecil[col*3]=32+31*(-sin(col*PI/RED));
   palettecil[col*3+1]=32+31*(-sin(col*PI/GREEN));
   palettecil[col*3+2]=32+31*(-sin(col*PI/BLUE));
  }
 } 
 SetRGB(1,63,63,63);

  fractik(5);
  fillpage(video,0,64000);
  fillpage(virt,0,64000);
  fillpage(palette,0,768);
  cam.x=0;
  cam.y=0;
  cam.z=400;
  declare3(&obj);         // skus odkomentovat
  hvezda(&obj2);
  sincosini();
  Ginitnorm(&obj2,&light,&lightn);
  Ginitnorm(&obj,&light,&lightn);
  //casovac
  frame_cnt=0;
  do
   { 
    usecount=get_nb_vbl();
    if (frame_cnt<63)  fadeuppal(1),setpalette();
    Flippage(virt,Fractal);
    uppgradeobject(&obj);   
    uppgradeobject(&obj2);   
    Gzxyrout(&obj);
    Gzxyrout(&obj2);
    perspektive(&obj);
    perspektive(&obj2);
    Greadin(&obj);
    Gputpolys(&obj);
    Greadin(&obj2);
    Gputpolys(&obj2);
    frame_cnt++;
    if (frame_cnt>200 && frame_cnt<1500) printspr(168,22,215,35,220,20,1,virt);
    if (frame_cnt>500 && frame_cnt<1500) printspr(221,22,245,35,235,44,1,virt);
    if (frame_cnt>800 && frame_cnt<1500) printspr(252,22,295,35,220,64,1,virt);
    if ((frame_cnt%35)==0)  
     {pocet++;
      obj2.objpos.z-=incz;
      for(col=1;col<(obj.Nvertex+1);col++)
      {
       obj.orgvertexes[col].x+=obj.vertnorm[col].x*incz;
       obj.orgvertexes[col].y+=obj.vertnorm[col].y*incz;
       obj.orgvertexes[col].z+=obj.vertnorm[col].z*incz;
      }
     }
    if (pocet==40) incz=(-1)*incz,pocet=0;

/*synchr about music, fade after position 1c*/
    get_info(&position,&pattern,&note,&volume,&sfx_volume);
    if (position>=0x1C)
     {
      fillpage(palettecil,0,768);
      fadedownpal(1),setpalette();
     }

/*synchr about frames
    if (frame_cnt>2136)
     {
      fillpage(palettecil,0,768);
      fadedownpal(1),setpalette();
     }
*/
    waitforVR();
    do { }  while ((get_nb_vbl()-usecount)<=cek3d1);
    Flippage(video,virt);
    fillpage(virt,0,64000);
    get_info(&position,&pattern,&note,&volume,&sfx_volume);
/*Tady to blykne se zacatkem 23 24 25 patternu*/    
    if(position>22 && position<26 )
     {
      if (skonceno==position)
       {
        memcpy(palettecil,palette,768);
        fillpage(palette,63,768);
        setpalette();
	skonceno++;
       }
      fadedownpal(1),setpalette();
     }
   }
  while(!kbhit() && position<0x1D);  /*po 1C=27 patternu vypadni*/  
/*takhle jsem to synchronozoval na pocet frejmu
  while ((!kbhit()) && frame_cnt<2210);
*/

  cube(&obj);
  memset(data,0,128*128);
  Vpcxloada(128*128,data,tdata,sizeof(tdata));
  //aby paleta byla v rozsahu 0-64
  for(col=0;col<256;col++)
  {
   palette[col*3]>>=2;
   palette[(col*3)+1]>>=2;
   palette[(col*3)+2]>>=2;
  }
  memcpy(palettecil,palette,768);
  fillpage(palette,0,768);
  for(pocet=1;pocet<=obj.Npolys;pocet++)
   obj.polys[pocet].textura=data;
  Ginitnorm(&obj,&light,&lightn);
  preptexture(&obj);
  frame_cnt=0,pocet=0,incz=1;
  do
   { 
    usecount=get_nb_vbl();
    if (frame_cnt<63)  fadeuppal(1),setpalette();
    uppgradeobject(&obj);
    Gzxyrout(&obj);
    perspektive(&obj);
    Greadin(&obj);
    textrputpolys(&obj);
    if ((frame_cnt%2)==0)  
     {
      pocet++;
      obj.objpos.z-=incz*2;
     }
    if (pocet==70) incz=(-1)*incz,pocet=0;
    if (frame_cnt==400) 
     {
      obj.degreinc.x=2;
      obj.degreinc.y=1;
      fillpage(palettecil,0,768);
     } 
    if (frame_cnt>400 && frame_cnt<900)
      {
       printspr(1,38,155,51,100,20,240,virt);
       printspr(159,42,211,51,140,44,240,virt);
      }
    if (frame_cnt>1500)  fadedownpal(1),setpalette();
    frame_cnt++;
    waitforVR();
    do { }  while ((get_nb_vbl()-usecount)<=cek3d2);
    Flippage(video,virt);
    fillpage(virt,0,64000);
   }
  while ( !kbhit() && frame_cnt<1570);
}
