.486p
.Model Flat

CODE SEGMENT PARA PUBLIC USE32

;=============================================================================
;====Watcom declarace
;====extern void fillpage(char *dest,int color,int count);
;====#pragma aux fillpage parm [edi] [ebx] [ecx];

public fillpage_
fillpage_ proc
   pushad
   shr ecx,2
   xor eax,eax
   mov al,bl
   mov ah,al
   mov dx,ax
   shl eax,16
   mov ax,dx
   rep  stosd
   popad
   ret 
fillpage_ endp

;=============================================================================
;====Watcom declarace
;====extern void SetvMODE(int number);
;====#pragma aux SetvMODE parm [eax];

public SetvMODE_
SetvMODE_ proc
  pusha
  int 10h
  popa
  ret
SetvMODE_ endp

;=============================================================================
;====Watcom declarace
;====extern void Flippage(char *Dest, char *Src);
;====#pragma aux Flippage parm [edi] [esi];

public Flippage_

Flippage_ proc
        
        pushad 
        mov ecx, 16000

        cld
        rep movsd

        popad
        ret
Flippage_ endp


;===========================================================================
;====Watcom declarace
;====extern void SetPixel(int x, int y,int color, char *where);
;====#pragma aux SetPixel parm [ecx] [eax] [edx] [edi];

public SetPixel_

setPixel_ proc

	pusha
        shl eax,6 
        mov ebx,eax
        shl eax,2
        add ebx,eax
        xchg eax,ebx
        add eax, ecx     ;eax=x+y*320

	add edi,eax      ;where+x+y*320
        
	mov eax, edx     ;eax=color
	stosb
	popa
	ret

SetPixel_ endp


;===========================================================================
;====Watcom declarace
;====extern void hline(int x1, int x2, int y, int color, char *curpage);
;====pragma aux  hline parm [ecx] [ebx] [eax] [edx] [edi];
; hline procedure used in poly filling, 
; NO CLIPP

public hline_

hline_ proc

        pushad
        push edx
        push ebx       

        mov ebx, 320
        mul ebx
        pop ebx

        add eax, ecx
        add edi, eax
        sub ebx, ecx
        mov ecx, ebx

        pop edx
        mov eax,edx 

        cld
        rep stosb

        popad
        ret

hline_ endp

;===========================================================================
;====Watcom declarace
;====extern void ghline(int x1, int c1, int x2, int c2, int y,char *curpage);
;====pragma aux ghline parm [ecx] [esi] [ebx]   [edx]     [eax]      [edi];

; NO CLIPP
; draws a horizontal line from (x1, y) to (x2, y) and interpolates colors
; (byte granularity) from c1 to c2 in the process.  


public gHline_

gHline_ proc     ; gouraud horizontal line routine

        pusha

        push ebx
        push edx
        mov ebx, 320
        mul ebx       ; eax=y*320
        pop edx       ; MUL destroy EDX !!!!
        pop ebx       

        mov edi, edi    ; dest videopage


;        cmp ebx, ecx   ; clipping is in C code
;        jg ghlDraw
;        xchg ebx, ecx
;        xchg esi, edx

;ghlDraw:

;        cmp ecx, 0
;        jge ghlx1ok
;        mov ecx, 0

ghlx1ok:
;        cmp ecx, 319
;        jge ghldone

;        cmp ebx, 319
;        jl ghlx2ok
;        mov ebx, 319

;ghlx2ok:
;        cmp ebx, 0
;        jl ghldone


        add eax, ecx
        add edi, eax     ;edi x1+y*320

        sub ebx, ecx
        mov ecx, ebx     ;ecx x2-x1

        jecxz ghlDone


        mov eax, edx
        sub eax, esi           ; dc delta color
        shl eax, 8             ; dc *= 256
        xor edx, edx

        cmp eax, 0
        js ghlNeg
        div ebx                 ; get dcdx
        jmp ghlGoOn


ghlNeg:
        neg eax
        div ebx
        neg eax

ghlGoOn:
        mov edx, eax            ; edx = dcdx * 256
        mov ebx, esi            ; ebx = c1
        shl ebx, 8              ; ebx *= 256

        cld
        align 4

ghlLoop:
        jcxz ghlDone

        mov [edi], bh
        inc edi
        add ebx, edx

        dec ecx
        jmp ghlLoop

ghlDone:
        popa
        ret

ghline_ endp

CODE ENDS
END

