
#include <math.h>
#define M_PI 3.1415192
#define uchar unsigned char
#define uint  unsigned int

unsigned char *VGA = 0xa000 << 4;
unsigned char druha[64000];
int sx1=0, sx2=0, sy1=0, sy2=0; //to su nase startovacie indexy
int incy=-5;

int  sint[256];

void SetMode(int m);
#pragma aux SetMode = \
" int 10h"            \
parm [eax];

extern void Flippage(char *Dest, char *Src);
#pragma aux Flippage parm [edi] [esi];

extern void SetPixel(int x, int y,int color, char *where);
#pragma aux SetPixel parm [ecx] [eax] [edx] [edi];



void wait_ret(void)
{
   while (!(inp(0x3da) & 8)) ;
   while (inp(0x3da) & 8) ;
}

void shade_pal(int a, int b, uchar ar, uchar ag, uchar ab,
                             uchar br, uchar bg, uchar bb){
// nastavy usek palety a az b na odtiene farieb a->b
  uchar fr, fg, fb;
  int i;
  for(i=a; i<=b; i++){
     fr=ar+((i-a)*(br-ar)/(b-a));
     fg=ag+((i-a)*(bg-ag)/(b-a));
     fb=ab+((i-a)*(bb-ab)/(b-a));
     outp(0x3c8, i);
     outp(0x3c9, fr);
     outp(0x3c9, fg);
     outp(0x3c9, fb);
  }
}


void precalc(void){
  int i;
  for(i=-128; i<128; i++)
    sint[i+128]=80*sin(abs(i)*M_PI/256);  //nastavim si sinusy
   // sint[i]=130+(120*cos(sqrt(200-i)*sin(sqrt(320-i))));
}

void plasmatic_fridge(void){
  uchar px1, px2, py1, py2; //pomocne body
  int x, y;

  py1=sy1;
  py2=sy2;
  for(y=0; y<200; y++)
   {px1=sx1,px2=sx2;
    for(x=0; x<320; x++)
    {
     SetPixel(x,y,sint[py1]+sint[py2]+sint[px1]+sint[px2],druha);
     px1+=1;
     px2+=1;
    }
    py1+=2;
    py2+=1;
  }
}

void main(void)
{
 int cisl=1;
 int pocet=0; 
 int frame_cnt;
 
 SetMode(0x13); //nastavim mod 320x200 256 farieb

  // nastavim nejaku tu paletu
  shade_pal(0,63,    0,0,0,10,10,10);
  shade_pal(64,127,  10,10,10,30,30,30);
  shade_pal(128,191, 30,30,30,21,22,63);
  shade_pal(192,255, 21,22,63,0,0,0);

  precalc(); //predpocitam si tabulky sin a y-offset
  frame_cnt=0;
  do{
    plasmatic_fridge(); //vypocitam plasmu
 //   wait_ret(); //cakanie na retrace - nema velky efekt
    Flippage(VGA,druha);
    //posuniem startovacie body 
    sx1+=3+incy;
    sx2-=5;
    sy1+=3;
    sy2+=incy*3;
    if((frame_cnt%20)==0) incy+=cisl,pocet++;
    if(pocet==10) cisl=(-1)*cisl,pocet=0; 
    frame_cnt++;
    }while(!kbhit());

  SetMode(0x3); //dam tam textmode
}

