#include<stdio.h>
#include<math.h>
#include<process.h>
#include<stdlib.h>
#include<string.h>
#include<bios.h>
#include "grf.h"
#include "kreis.dat"  //textura na blob
#include "..\resource\eos.h"

#define cekbl 1
#define cek3d1 1
#define cek3d2 2
#define cekpl 3

//virtualni obrazovka
unsigned char virt[64000];
//obrazovka
unsigned char *video = 0xa000 << 4;
unsigned int frame_cnt=0;
unsigned char Fractal[320*200];
unsigned char Vpismo[320*200];
long usecount;
unsigned int col;
unsigned char data[128*128];

unsigned char palette[768];
unsigned char palettecil[768];

int  card=0,port=1,irq=2,dma=3,infos=4;
unsigned char  position=1,pattern=2,note=3,volume=4,sfx_volume=5;


void fadeuppal(int speed)
{ 
  for(col=0;col<256;col++)
  {
   if (palette[col*3]<palettecil[col*3]) palette[col*3]+=speed;
   if (palette[(col*3)+1]<palettecil[(col*3)+1]) palette[(col*3)+1]+=speed;
   if (palette[(col*3)+2]<palettecil[(col*3)+2]) palette[(col*3)+2]+=speed;
   }
}

void fadedownpal(int speed)
{ 
  for(col=0;col<256;col++)
  {
   if (palette[col*3]>palettecil[col*3]) palette[col*3]-=speed;
   if (palette[(col*3)+1]>palettecil[(col*3)+1]) palette[(col*3)+1]-=speed;
   if (palette[(col*3)+2]>palettecil[(col*3)+2]) palette[(col*3)+2]-=speed;
   }
}


void setpalette(void)
{ for(col=0;col<256;col++)
  {
   int r,g,b;
   r=palette[col*3];
   g=palette[(col*3)+1];
   b=palette[(col*3)+2];
   SetRGB(col,r,g,b);
   }
}

#include "pismo.dat"
#include "pismo.c"
#include "ohen.c"
#include "blob.c"
#include "3dpr1.c"
#include "fract.c"
#include "plasma1.c"


void main(void)
{
init_eos(_psp);
card=detect_sound_card  (1,&port,&irq,&dma,&infos);
printf ("     Card : %x Port : %x   Irq : %i   Dma : %i \n",card,port,irq,dma);
load_module ("snd.dat",1,44100,0);
set_volume(63,63);
play_module();
change_synchro_int_08(70);

Vpcxloada(320*200,Vpismo,pismo,sizeof(pismo)); 
fillpage(palette,0,768);
SetvMODE(0x13);
    blob2D();
    part3D1();
    plasma();
//wait for sound fade patern n 
SetvMODE(0x3);
stop_module();
clear_module();
printf("Sulfur15CH done.\n");
printf("Code:Optik\nSound:Optik\nEat homeopatiks!!!\n");
}
