
int sx1=0, sx2=0, sy1=0, sy2=0; 

int  sin2t[256];


void shade_pal(int a, int b, unsigned char ar, unsigned char ag, unsigned char ab,
               unsigned char br, unsigned char bg, unsigned char bb){
// nastavy usek palety a az b na barvy a->b linearne
  unsigned char fr, fg, fb;
  int i;
  for(i=a; i<=b; i++){
     fr=ar+((i-a)*(br-ar)/(b-a));
     fg=ag+((i-a)*(bg-ag)/(b-a));
     fb=ab+((i-a)*(bb-ab)/(b-a));
     palettecil[i*3]=fr;
     palettecil[(i*3)+1]=fg;
     palettecil[(i*3)+2]=fb;
   }  
}


void precalc(void){
  int i;
  for(i=-128; i<129; i++)
    sin2t[i+128]=80*sin(abs(i)*PI/256);
}

void plasmatic(void)
{
  unsigned char px1, px2, py1, py2; //pomocne body
  int x, y;

  py1=sy1;
  py2=sy2;
  for(y=0; y<200; y++)
   {px1=sx1,px2=sx2;
    for(x=0; x<320; x++)
    {
     SetPixel(x,y,sin2t[py1]+sin2t[py2]+sin2t[px1]+sin2t[px2],virt);
     px1+=1;
     px2+=1;
    }
    py1+=2;
    py2+=1;
  }
}

void plasma(void)
{ int pocet=0;
  int incy=-5;
  int cisl=1;

  shade_pal(0,63,    0,0,0,10,10,10);
  shade_pal(64,127,  10,10,10,30,30,30);
  shade_pal(128,191, 30,30,30,21,22,63);
  shade_pal(192,255, 21,22,63,0,0,0);
  precalc(); //predpocitam sinus 
  obj2.objpos.z=-270;
  obj2.degreinc.x=obj.degreinc.y=obj2.degreinc.z=3;
  frame_cnt=0;
  fillpage(palette,0,768);
  do
   {
    usecount=get_nb_vbl();
    //posunti start bodu
    if (frame_cnt<64) fadeuppal(1),setpalette();
    sx1+=3+incy;
    sx2-=5;
    sy1+=3;
    sy2+=incy*3;
    if((frame_cnt%20)==0) incy+=cisl,pocet++;
    if(pocet==10) cisl=(-1)*cisl,pocet=0; 
    plasmatic();
    //3D
    uppgradeobject(&obj2);   
    zxyrout(&obj2);
    perspektive(&obj2);
    Greadin(&obj2);
    putWirepolys(&obj2,191);
    //
    if (frame_cnt>100 && frame_cnt<390) printspr(1,52,64,69,20,20,128,virt);
    if (frame_cnt>110 && frame_cnt<250)
      {
       printspr(72,54,136,70,70,45,128,virt);
       printspr(129,54,148,68,70,70,128,virt);
      }
    if (frame_cnt>250 && frame_cnt<390)
     {
       printspr(149,54,213,68,70,45,128,virt);
       printspr(216,54,289,68,70,70,128,virt);
       printspr(1,75,47,84,148,74,128,virt);
       printspr(48,72,107,88,70,95,128,virt);
       fillpage(palettecil,0,768);
     }
    if (frame_cnt>390)
     {
       printspr(6,5,68,19,100,80,128,virt);
       printspr(120,22,163,35,190,81,128,virt);
       fillpage(palettecil,0,768);
     }
    do { }  while ((get_nb_vbl()-usecount)<=cekpl);
    Flippage(video,virt);
    frame_cnt++;
    get_info(&position,&pattern,&note,&volume,&sfx_volume);
    if (position>=0x3A)
    {
     fadedownpal(1); 
     setpalette();
    }
   }while(!kbhit() && position<0x3B);
}    
